<template>
  <div class="submenu desktopshow">
    <div
      class="item"
      :class="{ active: item.href === itemActive }"
      :id="item.id"
      v-for="(item, index0) in submenuList"
      :key="'i'+index0">
      <flink
        :href="`/cabinet/${menuActive}/${item.href}`"
        @mousedown.native="checkNavigation(item.id, $event)"
        class="name">{{ item.name }}</flink>
      <div
        v-if="item.helptext"
        class="question">
        <div
          class="button"
          v-tooltip="{
            classes: 'tooltip tooltipWhite tooltipCabinetSubmenu',
            trigger: 'hover',
            offset: '16',
            placement: 'right',
            html: 'true',
            content: item.helptext,
        }"/>
      </div>
    </div>
  </div>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';
import { SHOW } from '~/assets/js/store/infoModal/action-types';

const STORE_INFO_MODAL = createNamespacedHelpers('infoModal');
const STORE_USER = createNamespacedHelpers('user');

export default {
  name: 'Submenu',
  props: {
    itemActive: {
      type: String,
      default: null,
    },
    menuActive: {
      type: String,
      default: 'wrench',
    },
    disableLeave: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    ...STORE_USER.mapState(['auth']),
    ...STORE_USER.mapGetters(['organizationsEditAvailable', 'shopsEditAvailable']),
    submenuList() {
      const submenuList = [];
      if (this.menuActive === 'wrench') {
        submenuList.push(
          {
            id: 'guide-profile',
            name: 'Мой профиль',
            href: 'profile',
            helptext: 'Информация о&nbsp;владельце личного кабинета',
          },
        );
        if (this.auth.isOrganization) {
          submenuList.push(
            {
              id: 'guide-credential',
              name: 'Реквизиты организации',
              href: 'organization-info',
              helptext: 'Подробная информация о&nbsp;юридических лицах организации.',
            },
          );
          submenuList.push(
            {
              id: 'guide-retail',
              name: 'Магазины запчастей и автотехцентры',
              href: 'organization-sto',
              helptext: 'Подробная информация о&nbsp;магазинах и технических центрах организации.',
            },
          );
        }
        submenuList.push(
          {
            id: 'guide-notification-setup',
            name: 'Настройка уведомлений',
            href: 'notification-setup',
            helptext: 'Перечень возможных рассылок, на&nbsp;которые можно как подписаться, так&nbsp;и&nbsp;отписаться.',
          },
        );
      }
      if (this.menuActive === 'inbox') {
        submenuList.push(
          {
            id: 'guide-inbox',
            name: 'Входящие запросы',
            href: '',
            helptext: 'Запросы, которые поступают от покупателей из разделов "Поиск по номеру" и "Запрос на запчасть".',
          },
        );
        submenuList.push(
          {
            id: 'guide-inbox-settings',
            name: 'Настройка входящих запросов',
            href: 'settings',
            helptext: 'Позволяет получать запросы из раздела "Запрос на запчасть", для этого создайте задачу и укажите '
              + 'какие марки, модели и типы запчастей Вы готовы продать. <br>Согласно Вашим настройкам Вы будете '
              + 'получать запросы от покупателей. ',
          },
        );
        submenuList.push(
          {
            id: 'guide-inbox-helper',
            name: 'Помощь',
            href: 'helper',
            helptext: null,
          },
        );
      }
      if (this.menuActive === 'price-upload') {
        submenuList.push(
          {
            id: 'price-upload',
            name: 'Загрузки',
            href: 'upload',
            helptext: null,
          },
        );
        submenuList.push(
          {
            id: 'price-template',
            name: 'Шаблоны загрузок',
            href: 'template',
            helptext: null,
          },
        );
        submenuList.push(
          {
            id: 'price-history',
            name: 'История загрузок',
            href: 'history',
            helptext: null,
          },
        );
        submenuList.push(
          {
            id: 'price-rules',
            name: 'Правила загрузки прайсов',
            href: 'rules',
            helptext: null,
          },
        );
        submenuList.push(
          {
            id: 'price-requirements',
            name: 'Требования к загружаемым товарам',
            href: 'requirements',
            helptext: null,
          },
        );
      }
      return submenuList;
    },
  },
  methods: {
    ...STORE_INFO_MODAL.mapActions({
      showInfo: SHOW,
    }),
    checkNavigation(id, event) {
      switch (id) {
        case 'guide-credential':
          if (!this.organizationsEditAvailable) {
            this.showInfo({
              text: 'Для добавления организаций нужно заполнить профиль.',
              buttonVisibility: false,
            });
            this.$ym('lk_modal_shown');
            event.stopImmediatePropagation();
            event.preventDefault();
            return false;
          }
          break;
        case 'guide-retail':
          if (!this.shopsEditAvailable) {
            this.showInfo({
              text: 'Для добавления магазинов и автотехцентров нужно добавить хотя бы одну организацию.',
              buttonVisibility: false,
            });
            this.$ym('lk_modal_shown');
            event.stopImmediatePropagation();
            event.preventDefault();
            return false;
          }
          break;
        default:
      }
      return true;
    },
  },
};
</script>

<style lang="postcss">
  .tooltip.tooltipCabinetSubmenu {
    max-width: 24rem;
  }
  .question {
    position: relative;
    display: inline-flex;
    > .button {
      display: inline-flex;
      justify-content: center;
      align-items: center;
      width: 1rem;
      height: 1rem;
      padding: 0;
      min-height: auto;
      background: transparent;
      border: 1px solid #9badb9;
      border-radius: 50%;
      outline: 0;
      cursor: pointer;
      &:before {
        display: inline-flex;
        content: "?";
        font-size: 0.75rem;
        line-height: 1;
        color: #4272a4;
      }
    }
  }

  .submenu {
    display: flex;
    flex-flow: row nowrap;
    justify-content: flex-start;
    align-items: center;
    width: 100%;
    height: 3rem;
    max-height: 3rem;
    background-color: var(--bg-dark);

    .item {
      display: inline-flex;
      flex-flow: row nowrap;
      justify-content: center;
      align-items: center;
      height: 100%;
      padding: 1rem 2rem;
      cursor: pointer;
      .name {
        font-size: 0.75rem;
        line-height: 1;
        color: var(--color-main);
        transition: 0.1s color var(--transition-easeOutQuad);
      }
      .question {
        margin-left: 0.5rem;
      }
      &:not(.active):hover {
        .name {
          color: var(--link-color);
        }
      }
      &.active {
        font-weight: var(--font-weight-medium);
        background-color: var(--bg-main);
        pointer-events: none;
        .question {
          pointer-events: auto;
        }
      }
    }

  }
</style>
